## @file Load.py
#  @author Steven Palmer and Henry Madej
#  @brief function for retrieving data from file
#  @date 20/02/2018

from Data import *
from CurveADT import *

## @brief Load reads in data from a file, storing it in Data 
#  @param s the name of the file to be read
def Load(s):
  with open(s, 'r') as infile:
    contents = infile.readlines()
    
  contents = [x.strip().split(',') for x in contents]
  
  zs = contents[0]
  os = contents[1]
  pts = contents[2:]
  
  Data.init()
  
  for i in range(len(zs)):
    X = []
    Y = []
    for j in range(0, len(pts)):
      if pts[j][i*2] == '':
        break
      X.append(float(pts[j][i*2]))
      Y.append(float(pts[j][i*2+1]))
      
    Data.add(CurveT(X,Y,int(os[i])), float(zs[i]))
  
  
   
