#ifndef POINTADT_H
#define POINTADT_H

#include <functional>

class PointT 
{
  private: 
    int xc;
    int yc;
  
  public:
    PointT(int x, int y);
    int x() const;
    int y() const;
    PointT translate(int dx, int dy) const;
};


// overloading comparison operators for convenience
inline bool operator==(const PointT& lhs, const PointT& rhs)
{
  return lhs.x() == rhs.x() && lhs.y() == rhs.y();
}
inline bool operator!=(const PointT& lhs, const PointT& rhs)
{
  return !operator==(lhs, rhs);
}


namespace std
{
  template <>
  struct hash<PointT>
  {
    size_t operator()(const PointT& p) const
    {
      return p.x() ^ p.y();
    }
  };
}

#endif