/*
 *  use this file for experimenting with your code,
 *  testing things that don't work, debugging, etc.
 *  
 *  you can compile and run this via 'make experiment'
 *
 *  this file will not be graded
 */
 
#include "GameBoard.h"
#include "CardDeckUtils.h"
#include "CardTypes.h"
#include <vector>
#include <iostream>

int main() 
{
  // std::vector<CardT> deck = CardDeckUtils::randomDeck();
  // std::cout << deck.size() << std::endl;
  // std::vector<CardStackT> cardStacks = GameBoard::tableauDeck(deck);
  // std::cout << cardStacks.size() << std::endl;

  GameBoardT gb = GameBoardT();
  CardT c0(H, A);
  CardT c1(C, C2);
  CardT c2(D, C3);

  CardStackT stack = CardStackT(19,std::vector<CardT>());

  stack = stack.push(c0);
  stack = stack.pop();
  //stack = stack.pop();

  gb.place(Tableau, 0, c0);
  gb.place(Tableau, 1, c1);
  gb.place(Tableau, 2, c2);

  std::cout << "Move T1 to T0: " << gb.isValidMove(Tableau, 1, Tableau, 0) << std::endl;
  std::cout << "Move T0 to T1: " << gb.isValidMove(Tableau, 0, Tableau, 1) << std::endl;
  std::cout << "Move T1 to T2: " << gb.isValidMove(Tableau, 1, Tableau, 2) << std::endl;
  std::cout << "Move T0 to T2: " << gb.isValidMove(Tableau, 0, Tableau, 2) << std::endl;

  gb.makeMove(Tableau, 1, Tableau, 2);

  std::cout << "Move T1 to T0: " << gb.isValidMove(Tableau, 1, Tableau, 0) << std::endl;
  std::cout << "Move T0 to T1: " << gb.isValidMove(Tableau, 0, Tableau, 1) << std::endl;
  std::cout << "Move T1 to T2: " << gb.isValidMove(Tableau, 1, Tableau, 2) << std::endl;
  std::cout << "Move T0 to T2: " << gb.isValidMove(Tableau, 0, Tableau, 2) << std::endl;

  gb.makeMove(Tableau, 0, Tableau, 2);

  std::cout << "Move T1 to T0: " << gb.isValidMove(Tableau, 1, Tableau, 0) << std::endl;
  std::cout << "Move T0 to T1: " << gb.isValidMove(Tableau, 0, Tableau, 1) << std::endl;
  std::cout << "Move T1 to T2: " << gb.isValidMove(Tableau, 1, Tableau, 2) << std::endl;
  std::cout << "Move T0 to T2: " << gb.isValidMove(Tableau, 0, Tableau, 2) << std::endl;
  std::cout << "Move T2 to T0: " << gb.isValidMove(Tableau, 2, Tableau, 0) << std::endl;
  std::cout << std::endl;
  std::cout << "validMoveExists: " << gb.validMoveExists() << std::endl;
  std::cout << "isInWinState: " << gb.isInWinState() << std::endl;

  gb = GameBoardT(CardDeckUtils::randomDeck());

  return 0;
}