/**
 * \file CardTypes.h
 * \brief Provides enumerated types for representing a card in a deck of cards.
 * \author Christopher W. Schankula, MacID: schankuc
 * \date April 8th, 2018
*/

#ifndef CARDTYPES_H
#define CARDTYPES_H


/**
 * \brief Enumerated type representing the four suits of a card: Hearts (H), Diamonds (D), Clubs (C) and Spades (S).
*/
enum SuitT {H, D, C, S};

/**
 * \brief Enumerated type representing the ranks of a card in a deck of cards (Ace, 2-10, Jack, Queen, King).
*/
enum RankT {A, C2, C3, C4, C5, C6, C7, C8, C9, C10, J, Q, K};

/**
 * \brief Enumerated type representing the possible colours of a card in a deck of cards (Red or Black).
*/
enum ColourT {Red, Black};

#endif