/**
 * \file Exceptions.h
 * \brief Defines exceptions for use in this project.
 * \author Christopher W. Schankula, MacID: schankuc
 * \date April 9th, 2018
*/

#ifndef EXCEPTIONS_H
#define EXCEPTIONS_H

#include <exception>

class invalid_argument : public std::exception {
   const char * what () const throw () {
      return "invalid argument";
   }
};

class invalid_config : public std::exception {
   const char * what () const throw () {
      return "invalid board configuration";
   }
};

class invalid_cell : public std::exception {
   const char * what () const throw () {
      return "invalid cell, cell does not exist on gameboard";
   }
};

class invalid_move : public std::exception {
   const char * what () const throw () {
      return "invalid move, this move cannot be made according to the rules of FreeCell.";
   }
};

class stack_full : public std::exception {
   const char * what () const throw () {
      return "cannot push to stack, stack is full";
   }
};

class stack_empty : public std::exception {
   const char * what () const throw () {
      return "cannot perform top or pop operation, stack is empty";
   }
};

#endif