/**
 * \file CardDeckUtils.cpp
 * \brief Implementation of functions described by CardDeckUtils.h. Provides funcitons for generating
 * and shuffling a deck of cards.
 * \author Christopher W. Schankula, MacID: schankuc
 * \date April 8th, 2018
*/

#include "CardDeckUtils.h"
#include "CardADT.h"
#include "CardTypes.h"
#include <vector>
#include <stdlib.h>

std::vector<CardT> CardDeckUtils::deckSet(){
	RankT ranks[] = {A, C2, C3, C4, C5, C6, C7, C8, C9, C10, J, Q, K};
	SuitT suits[] = {H, D, S, C};

	std::vector<CardT> deck = std::vector<CardT>();

	for (int i = 0; i < 4; i++)
		for (int j = 0; j < 13; j++)
			deck.push_back(CardT(suits[i], ranks[j]));
	return deck;
}

std::vector<CardT> CardDeckUtils::permute(std::vector<CardT> inSet){
	srand(time(NULL));

	for (int i = 0; i < 1000; i++){
		int j = rand() % 52;
		int k = rand() % 52;

		CardT tmp = inSet[j];
		inSet[j] = inSet[k];
		inSet[k] = tmp;
	}

	return inSet;
}

std::vector<CardT> CardDeckUtils::randomDeck(){
	return permute(deckSet());
}