/**
 * \file testCardADT.cpp
 * \brief Implementation of CardT tests.
 * \author Christopher W. Schankula, MacID: schankuc
 * \date April 9th, 2018
*/

#include "catch.h"
#include "CardADT.h"
#include "CardTypes.h"

TEST_CASE( "tests for CardT" , "[CardT]" ) {
  CardT c0(H, C2);
  CardT c1(D, C9);
  CardT c2(S, K);
  CardT c3(C, J);

  SECTION("test constuctor"){
    CardT newC0(D, C2);

    REQUIRE(newC0.getRank() == C2);
    REQUIRE(newC0.getSuit() == D);
  }

  SECTION("test getSuit() returns correct value"){
    REQUIRE(c0.getSuit() == H);
    REQUIRE(c1.getSuit() == D);
    REQUIRE(c2.getSuit() == S);
    REQUIRE(c3.getSuit() == C);
  }

  SECTION("test getColour() returns correct value"){
    REQUIRE(c0.getColour() == Red);
    REQUIRE(c1.getColour() == Red);
    REQUIRE(c2.getColour() == Black);
    REQUIRE(c3.getColour() == Black);
  }

  SECTION("test getRank() returns correct value"){
    REQUIRE(c0.getRank() == C2);
    REQUIRE(c1.getRank() == C9);
    REQUIRE(c2.getRank() == K);
    REQUIRE(c3.getRank() == J);
  }
	
}
