#include "DataSetTemplate.h"

#include "PointT.h"
#include "BankAccount.h"

template <class T>
DataSetTemplate<T>::DataSetTemplate() : maximum()
{
  this->sum = 0.0;
  this->count = 0;
}

template <class T>
void DataSetTemplate<T>::add(T x)
{
   this->sum += x.getMeasure();
   if (count == 0 || maximum.getMeasure() < x.getMeasure()) maximum = x;
   count++;
}

template <class T>
double DataSetTemplate<T>::getAverage()
{
   if (count == 0) return 0;
     else return sum/count;
}

template <class T>
T DataSetTemplate<T>::getMaximum()
{
   return maximum;
}

// explicit instantiations
template class DataSetTemplate<PointT>;
template class DataSetTemplate<BankAccount>;

