#include <cmath>
#include "EdgeT.h"
#include "NodeT.h"

const double EdgeT::TOLERANCE = 1e-5;


EdgeT::EdgeT(NodeT nod1, NodeT nod2) : n1(nod1), n2(nod2)
{}

NodeT EdgeT::node1()
{
  return this->n1;
}

NodeT EdgeT::node2()
{
  return this->n2;
}

double EdgeT::length()
{
  return this->n1.dist(n2);
}

bool EdgeT::is_horizontal()
{
  return std::abs(this->n1.ycoord() - this->n2.ycoord()) <= TOLERANCE;
}

bool EdgeT::equal(EdgeT e)
{
  return (this->n1.equal(e.node1()) && this->n2.equal(e.node2())) || (this->n1.equal(e.node2()) && this->n2.equal(e.node1()));
}
